import React from "react";
import { Animated, EasingFunction, TouchableWithoutFeedbackProps, TransformsStyle, ViewStyle } from "react-native";
import ModalLayerController from "./ModalLayerController";
import ModalLayerFactory from "./ModalLayerFactory";
interface ModalLayerProps {
    shadePress: TouchableWithoutFeedbackProps['onPress'];
    shade?: boolean;
    zIndex?: number;
}
interface ReactComponent {
    component: React.ComponentClass<any> | React.ReactElement<any> | null;
}
export interface ModalLayerShowOptions extends ReactComponent {
    boxStyle?: ViewStyle;
    act?: (ani: Animated.Value) => TransformsStyle['transform'];
}
export default class ModalLayer extends React.Component<ModalLayerProps> {
    state: {
        isShow: boolean;
        showAnimated: Animated.Value;
        transform: any[];
        boxStyle: {};
        contentComponent: any;
    };
    width?: number;
    isAction: boolean;
    contentComponent: ModalLayerShowOptions['component'];
    boxStyle: ViewStyle;
    transform: any;
    showEasing: EasingFunction;
    hideEasing: EasingFunction;
    showDuration: number;
    hideDuration: number;
    mlc: ModalLayerController;
    mlf: typeof ModalLayerFactory;
    private _subscriptions;
    private keyboardIsShow;
    private keyboardDidShowHandle;
    private keyboardDidHideHandle;
    componentDidMount(): void;
    componentWillUnmount(): void;
    toggle(isShow: any): Promise<unknown>;
    render(): JSX.Element;
    preload(component: any, callback?: any): void;
    show(options?: ModalLayerShowOptions, width?: number): Promise<unknown>;
    hide(): Promise<void>;
}
export {};
