import { EasingFunction, GestureResponderEvent, ViewStyle } from "react-native";
import React from "react";
import ModalLayer, { ModalLayerShowOptions } from "./ModalLayer";
export interface ModalControllerSetOptions {
    boxStyle?: ViewStyle;
    act?: ModalLayerShowOptions['act'];
    hideEasing?: EasingFunction;
    showEasing?: EasingFunction;
    showDuration?: number;
    hideDuration?: number;
    key?: string;
    backHandle?: (event: GestureResponderEvent) => boolean;
    width?: number;
}
export interface ModalControllerOptions extends ModalControllerSetOptions {
    component: React.ComponentClass<any> | React.ReactElement<any> | null | Function;
}
export default class ModalLayerController {
    key: string;
    private options;
    modalLayerRef: ModalLayer;
    constructor(key: string, options: ModalControllerOptions);
    private getComponent;
    show(...args: any[]): any;
    preload(...args: any[]): void;
    setOptions(options: ModalControllerSetOptions): void;
    hide(): void;
    backHandle(e: any): void;
    didHide: ((this: ModalLayerController) => void) | null;
    didShow: ((this: ModalLayerController) => void) | null;
    onShow: ((this: ModalLayerController) => void) | null;
    onHide: ((this: ModalLayerController) => void) | null;
    onLoad: ((this: ModalLayerController) => void) | null;
}
