import { TouchableWithoutFeedbackProps } from "react-native";
import React from "react";
import ModalLayerController, { ModalControllerOptions } from "./ModalLayerController";
import ModalLayers from "./ModalLayers";
export interface CreateOptions {
    shade?: boolean;
    shadePress?: TouchableWithoutFeedbackProps['onPress'];
    zIndex?: number;
}
interface CreateModalOptions extends CreateOptions, ModalControllerOptions {
}
export default class ModalLayerFactory {
    private static index;
    private static modalLayerControllers;
    private static self;
    static create(elem: CreateModalOptions | React.ElementType): ModalLayerController;
    static getLayer(key: string): ModalLayerController;
    static delete(mlc: ModalLayerController | ModalLayerController[]): void;
    static hideAll(): void;
    static forEach(func: (value: ModalLayerController) => void): void;
    static back(): boolean;
    static setModalLayersRef(mlsRef: ModalLayers): void;
    static setElevation(elevation: number): void;
}
export {};
